/*   $Source: /var/local/cvs/gasnet/mvapich2x-conduit/gasnet_core_snd_recv.c,v $
 *     $Date: 2012/05/04 07:21:37 $
 * $Revision: 1.69 $
 * Description: GASNet MVAPICH2X conduit Implementation
 * Copyright 2002, Dan Bonachea <bonachea@cs.berkeley.edu>
 * Terms of use are as specified in license.txt
 */

/*
 * Copyright (c) 2012-2014 The Ohio State University.  All rights reserved.
 *  
 * For detailed copyright and licensing information, please refer to the
 * LICENSE.TXT in the top level directory.
 */

#ifndef GASNET_UCR_COLLECTIVES_H
#define GASNET_UCR_COLLECTIVES_H

#ifndef GASNET_UCR_ERROR
#define GASNET_UCR_ERROR (-1)
#endif


int gasnet_ucr_barrier(gasnet_team_handle_t team);

int gasnet_ucr_broadcast(void *src, void *dst, int root, size_t size,
                         gasnet_team_handle_t team, int flags);

int gasnet_ucr_all_gather_all(void *dst, void *src, size_t nbytes,
                              gasnet_team_handle_t team, int flags);

int gasnet_ucr_reduce_all( void *target, const void *source, int op,
                           int datatype, int length,
                           gasnet_team_handle_t team, int flags);

int gasnet_ucr_reduce(int root,  void *target, const void *source,
                      int op, int datatype, int length,
                      gasnet_team_handle_t team, int flags);

int gasnete_ucr_barrier(gasnete_coll_team_t team, int *id_p, int *flags_p);

int gasnet_ucr_alltoall(void *target, const void *source, int length,
                        gasnet_team_handle_t team, int flags);

int gasnet_ucr_scatter(void *target, const void *source, int length,
                       int root, gasnet_team_handle_t team, int flags);

int gasnet_ucr_gather(void *dst, void *src, 
                          size_t nbytes, int root,
                          gasnet_team_handle_t team, int flags);

#endif


