/*
 * Copyright (c) 2012-2014 The Ohio State University.  All rights reserved.
 *  
 * For detailed copyright and licensing information, please refer to the
 * LICENSE.TXT in the top level directory.
 */


#ifndef UPCR_UCR_H
#define UPCR_UCR_H

typedef enum {
    ucr_sc,
    ucr_uc,
    ucr_ss,
    ucr_us,
    ucr_si,
    ucr_ui,
    ucr_sl,
    ucr_ul,
    ucr_f,
    ucr_d,
    ucr_ld
} ucr_reduce_type_t;

#define UNSUPPORTED_OP     -1

extern int upcr_ucr_reduce(int root,  void *target, const void *source, upc_op_t op, ucr_reduce_type_t type, int flags);
extern int upcr_ucr_reduce_all( void *target, const void *source, upc_op_t op, ucr_reduce_type_t type, int flags);
extern int upcr_my_partial_dummy_init(void *my_partial, upc_op_t op, ucr_reduce_type_t type);


#define COUNT_DUMMY_THREADS do{         \
    int i;                              \
    size_t my_skipped, i_count;         \
    for (i=0; i<upcri_threads; i++){    \
        if (i < start_thread) {         \
            my_skipped = blk_size;      \
        } else if (i == start_thread) { \
            i_count = start_phase;      \
        } else {                        \
            i_count = 0;                \
        }                               \
        i_count = blk_size * rows - i;  \
        if (i < end_thread) {           \
            i_count += blk_size;        \
        } else if (i == end_thread) {   \
            i_count += end_phase;       \
        }                               \
        if (0 == i_count){              \
            dummy_counter++;            \
        }                               \
    }                                   \
}                                       \
while(0)

#define XOR_RESULT do {                          \
    char *p = (char *)upcr_shared_to_local(dst); \
    size_t size = sizeof(UPCRI_COLL_RED_TYPE);   \
    int i;                                       \
    for (i=0; i<size; i++){                      \
        *p ^= 0;                                 \
        p++;                                     \
    }                                            \
}                                                \
while(0)

#define DECLARE_UCR_PREP_FN(name, suff, args, ...) \
    static inline \
    void ucr##name##suff##_fn( args ) {\
        __VA_ARGS__\
    }\

#define CALL_UCR_PREP_FN(name, suff, args, ...) \
     ucr##name##suff##_fn( args )

#define EVAL(MACRO, X, Y, ARGS, ...) MACRO(X, Y, ARGS, __VA_ARGS__)

EVAL(DECLARE_UCR_PREP_FN, type, UC, ucr_reduce_type_t *type, *type=ucr_uc;);
EVAL(DECLARE_UCR_PREP_FN, type, C,  ucr_reduce_type_t *type, *type=ucr_sc;);
EVAL(DECLARE_UCR_PREP_FN, type, US, ucr_reduce_type_t *type, *type=ucr_us;);
EVAL(DECLARE_UCR_PREP_FN, type, S,  ucr_reduce_type_t *type, *type=ucr_ss;);
EVAL(DECLARE_UCR_PREP_FN, type, UI, ucr_reduce_type_t *type, *type=ucr_ui;);
EVAL(DECLARE_UCR_PREP_FN, type, I,  ucr_reduce_type_t *type, *type=ucr_si;);
EVAL(DECLARE_UCR_PREP_FN, type, UL, ucr_reduce_type_t *type, *type=ucr_ul;);
EVAL(DECLARE_UCR_PREP_FN, type, L,  ucr_reduce_type_t *type, *type=ucr_sl;);
EVAL(DECLARE_UCR_PREP_FN, type, F,  ucr_reduce_type_t *type, *type=ucr_f; );
EVAL(DECLARE_UCR_PREP_FN, type, D,  ucr_reduce_type_t *type, *type=ucr_d; );
EVAL(DECLARE_UCR_PREP_FN, type, LD, ucr_reduce_type_t *type, *type=ucr_ld;);
#endif 
